/* math-converter.c generated by valac 0.40.10, the Vala compiler
 * generated from math-converter.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "calculator.h"
#include <stdlib.h>
#include <string.h>


#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
typedef struct _MathConverterPrivate MathConverterPrivate;
enum  {
	MATH_CONVERTER_0_PROPERTY,
	MATH_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* math_converter_properties[MATH_CONVERTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MATH_CONVERTER_CHANGED_SIGNAL,
	MATH_CONVERTER_NUM_SIGNALS
};
static guint math_converter_signals[MATH_CONVERTER_NUM_SIGNALS] = {0};

struct _MathConverter {
	GtkGrid parent_instance;
	MathConverterPrivate * priv;
};

struct _MathConverterClass {
	GtkGridClass parent_class;
};

struct _MathConverterPrivate {
	MathEquation* equation;
	gchar* category;
	GtkCellRendererText* from_renderer;
	GtkComboBox* from_combo;
	GtkComboBox* to_combo;
	GtkLabel* from_label;
	GtkLabel* to_label;
};


static gpointer math_converter_parent_class = NULL;

GType math_converter_get_type (void) G_GNUC_CONST;
#define MATH_CONVERTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MATH_CONVERTER, MathConverterPrivate))
MathConverter* math_converter_new (MathEquation* equation);
MathConverter* math_converter_construct (GType object_type,
                                         MathEquation* equation);
void math_converter_set_equation (MathConverter* self,
                                  MathEquation* equation);
static void __lambda11_ (MathConverter* self,
                  GParamSpec* pspec);
static void math_converter_update_result_label (MathConverter* self);
static void ___lambda11__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
static void math_converter_update_from_model (MathConverter* self);
gchar* math_converter_get_category (MathConverter* self);
void math_converter_set_conversion (MathConverter* self,
                                    const gchar* unit_a,
                                    const gchar* unit_b);
static gboolean math_converter_set_active_unit (MathConverter* self,
                                         GtkComboBox* combo,
                                         GtkTreeIter* iter,
                                         Unit* unit);
void math_converter_get_conversion (MathConverter* self,
                                    Unit* * from_unit,
                                    Unit* * to_unit);
static Number* math_converter_convert_equation (MathConverter* self,
                                         Number* x);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean math_converter_iter_is_unit (MathConverter* self,
                                      GtkTreeModel* model,
                                      GtkTreeIter* iter,
                                      Unit* unit);
static void math_converter_from_combobox_changed_cb (MathConverter* self);
static void _math_converter_from_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
static void math_converter_to_combobox_changed_cb (MathConverter* self);
static void _math_converter_to_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self);
static void math_converter_from_cell_data_func (MathConverter* self,
                                         GtkCellLayout* cell_layout,
                                         GtkCellRenderer* cell,
                                         GtkTreeModel* tree_model,
                                         GtkTreeIter* iter);
static void math_converter_swap_button_clicked_cb (MathConverter* self);
static void _math_converter_swap_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static GObject * math_converter_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _math_converter_from_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                    GtkCellRenderer* cell,
                                                                    GtkTreeModel* tree_model,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self);
static void _math_converter___lambda12_ (MathConverter* self);
static void __math_converter___lambda12__currency_manager_updated (CurrencyManager* _sender,
                                                            gpointer self);
static void math_converter_finalize (GObject * obj);


MathConverter*
math_converter_construct (GType object_type,
                          MathEquation* equation)
{
	MathConverter * self = NULL;
#line 40 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 40 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	self = (MathConverter*) g_object_new (object_type, NULL);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_set_equation (self, equation);
#line 40 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return self;
#line 145 "math-converter.c"
}


MathConverter*
math_converter_new (MathEquation* equation)
{
#line 40 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return math_converter_construct (TYPE_MATH_CONVERTER, equation);
#line 154 "math-converter.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return self ? g_object_ref (self) : NULL;
#line 163 "math-converter.c"
}


static void
__lambda11_ (MathConverter* self,
             GParamSpec* pspec)
{
#line 48 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (pspec != NULL);
#line 48 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_update_result_label (self);
#line 175 "math-converter.c"
}


static void
___lambda11__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 48 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	__lambda11_ ((MathConverter*) self, pspec);
#line 186 "math-converter.c"
}


void
math_converter_set_equation (MathConverter* self,
                             MathEquation* equation)
{
	MathEquation* _tmp0_;
#line 45 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 45 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (equation != NULL);
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = _g_object_ref0 (equation);
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (self->priv->equation);
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	self->priv->equation = _tmp0_;
#line 48 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_signal_connect_object ((GObject*) equation, "notify::display", (GCallback) ___lambda11__g_object_notify, self, 0);
#line 207 "math-converter.c"
}


void
math_converter_set_category (MathConverter* self,
                             const gchar* category)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 53 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 53 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, category) == 0) {
#line 54 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return;
#line 225 "math-converter.c"
	}
#line 55 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = g_strdup (category);
#line 55 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 55 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	self->priv->category = _tmp1_;
#line 57 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_update_from_model (self);
#line 235 "math-converter.c"
}


gchar*
math_converter_get_category (MathConverter* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 60 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	result = _tmp1_;
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return result;
#line 255 "math-converter.c"
}


void
math_converter_set_conversion (MathConverter* self,
                               const gchar* unit_a,
                               const gchar* unit_b)
{
	Unit* ua = NULL;
	UnitManager* _tmp0_;
	UnitManager* _tmp1_;
	Unit* _tmp2_;
	Unit* _tmp3_;
	Unit* ub = NULL;
	UnitManager* _tmp4_;
	UnitManager* _tmp5_;
	Unit* _tmp6_;
	Unit* _tmp7_;
	gboolean _tmp8_ = FALSE;
	Unit* _tmp9_;
	GtkComboBox* _tmp24_;
	Unit* _tmp25_;
	GtkComboBox* _tmp26_;
	Unit* _tmp27_;
#line 65 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 65 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (unit_a != NULL);
#line 65 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (unit_b != NULL);
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = unit_manager_get_default ();
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp2_ = unit_manager_get_unit_by_name (_tmp1_, unit_a);
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (_tmp1_);
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	ua = _tmp3_;
#line 68 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp4_ = unit_manager_get_default ();
#line 68 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 68 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp6_ = unit_manager_get_unit_by_name (_tmp5_, unit_b);
#line 68 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 68 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (_tmp5_);
#line 68 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	ub = _tmp7_;
#line 69 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp9_ = ua;
#line 69 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp9_ == NULL) {
#line 69 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp8_ = TRUE;
#line 316 "math-converter.c"
	} else {
		Unit* _tmp10_;
#line 69 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp10_ = ub;
#line 69 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 323 "math-converter.c"
	}
#line 69 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp8_) {
#line 327 "math-converter.c"
		GtkTreeModel* model = NULL;
		GtkComboBox* _tmp11_;
		GtkTreeModel* _tmp12_;
		GtkTreeModel* _tmp13_;
		GtkTreeIter iter = {0};
		GtkTreeModel* _tmp14_;
		GtkTreeIter _tmp15_ = {0};
		gboolean _tmp16_;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp11_ = self->priv->from_combo;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp12_ = gtk_combo_box_get_model (_tmp11_);
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		model = _tmp13_;
#line 74 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp14_ = model;
#line 74 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp16_ = gtk_tree_model_get_iter_first (_tmp14_, &_tmp15_);
#line 74 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		iter = _tmp15_;
#line 74 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		if (_tmp16_) {
#line 352 "math-converter.c"
			GtkTreeIter child_iter = {0};
			GtkComboBox* _tmp22_;
			GtkTreeIter _tmp23_;
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			while (TRUE) {
#line 358 "math-converter.c"
				GtkTreeModel* _tmp17_;
				GtkTreeIter _tmp18_;
				GtkTreeIter _tmp19_ = {0};
				gboolean _tmp20_;
				GtkTreeIter _tmp21_;
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp17_ = model;
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp18_ = iter;
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp20_ = gtk_tree_model_iter_children (_tmp17_, &_tmp19_, &_tmp18_);
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				child_iter = _tmp19_;
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				if (!_tmp20_) {
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					break;
#line 376 "math-converter.c"
				}
#line 78 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp21_ = child_iter;
#line 78 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				iter = _tmp21_;
#line 382 "math-converter.c"
			}
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			_tmp22_ = self->priv->from_combo;
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			_tmp23_ = iter;
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			gtk_combo_box_set_active_iter (_tmp22_, &_tmp23_);
#line 390 "math-converter.c"
		}
#line 81 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (model);
#line 81 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (ub);
#line 81 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (ua);
#line 81 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return;
#line 400 "math-converter.c"
	}
#line 84 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp24_ = self->priv->from_combo;
#line 84 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp25_ = ua;
#line 84 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp24_, NULL, _tmp25_);
#line 85 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp26_ = self->priv->to_combo;
#line 85 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp27_ = ub;
#line 85 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp26_, NULL, _tmp27_);
#line 65 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (ub);
#line 65 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (ua);
#line 418 "math-converter.c"
}


void
math_converter_get_conversion (MathConverter* self,
                               Unit* * from_unit,
                               Unit* * to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	GtkTreeIter from_iter = {0};
	GtkTreeIter to_iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkComboBox* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkComboBox* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_;
	GtkComboBox* _tmp7_;
	GtkTreeModel* _tmp8_;
	GtkTreeIter _tmp9_;
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 92 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 92 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	from_iter = _tmp1_;
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp2_ = self->priv->to_combo;
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_combo_box_get_active_iter (_tmp2_, &_tmp3_);
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	to_iter = _tmp3_;
#line 95 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp4_ = self->priv->from_combo;
#line 95 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp5_ = gtk_combo_box_get_model (_tmp4_);
#line 95 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp6_ = from_iter;
#line 95 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_tree_model_get (_tmp5_, &_tmp6_, 2, &_vala_from_unit, -1, -1);
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp7_ = self->priv->to_combo;
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp8_ = gtk_combo_box_get_model (_tmp7_);
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp9_ = to_iter;
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_tree_model_get (_tmp8_, &_tmp9_, 2, &_vala_to_unit, -1, -1);
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (from_unit) {
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		*from_unit = _vala_from_unit;
#line 475 "math-converter.c"
	} else {
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 479 "math-converter.c"
	}
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (to_unit) {
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		*to_unit = _vala_to_unit;
#line 485 "math-converter.c"
	} else {
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 489 "math-converter.c"
	}
}


static void
math_converter_update_result_label (MathConverter* self)
{
	Number* x = NULL;
	MathEquation* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* z = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
#line 99 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 101 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->equation;
#line 101 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = math_equation_get_number (_tmp0_);
#line 101 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 101 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	x = _tmp2_;
#line 102 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp3_ = x;
#line 102 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp3_ == NULL) {
#line 103 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (x);
#line 103 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return;
#line 524 "math-converter.c"
	}
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp4_ = x;
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp5_ = math_converter_convert_equation (self, _tmp4_);
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	z = _tmp5_;
#line 106 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp6_ = z;
#line 106 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp6_ != NULL) {
#line 536 "math-converter.c"
		Unit* source_unit = NULL;
		Unit* target_unit = NULL;
		Unit* _tmp7_ = NULL;
		Unit* _tmp8_ = NULL;
		gchar* source_text = NULL;
		Unit* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* target_text = NULL;
		Unit* _tmp12_;
		Number* _tmp13_;
		gchar* _tmp14_;
		GtkLabel* _tmp15_;
		const gchar* _tmp16_;
		GtkLabel* _tmp17_;
		const gchar* _tmp18_;
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		math_converter_get_conversion (self, &_tmp7_, &_tmp8_);
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (source_unit);
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		source_unit = _tmp7_;
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (target_unit);
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		target_unit = _tmp8_;
#line 111 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp9_ = source_unit;
#line 111 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp10_ = x;
#line 111 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp11_ = unit_format (_tmp9_, _tmp10_);
#line 111 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		source_text = _tmp11_;
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp12_ = target_unit;
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp13_ = z;
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp14_ = unit_format (_tmp12_, _tmp13_);
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		target_text = _tmp14_;
#line 113 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp15_ = self->priv->from_label;
#line 113 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp16_ = source_text;
#line 113 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		gtk_label_set_text (_tmp15_, _tmp16_);
#line 114 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp17_ = self->priv->to_label;
#line 114 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp18_ = target_text;
#line 114 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		gtk_label_set_text (_tmp17_, _tmp18_);
#line 106 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_free0 (target_text);
#line 106 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_free0 (source_text);
#line 106 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (target_unit);
#line 106 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (source_unit);
#line 599 "math-converter.c"
	}
#line 99 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (z);
#line 99 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (x);
#line 605 "math-converter.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 122 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 614 "math-converter.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 122 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 623 "math-converter.c"
}


static void
math_converter_update_from_model (MathConverter* self)
{
	GtkTreeStore* from_model = NULL;
	GtkTreeStore* _tmp0_;
	const gchar* _tmp1_;
	GtkComboBox* _tmp49_;
	GtkTreeStore* _tmp50_;
#line 118 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = gtk_tree_store_new (3, G_TYPE_STRING, TYPE_UNIT_CATEGORY, TYPE_UNIT);
#line 120 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	from_model = _tmp0_;
#line 122 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = self->priv->category;
#line 122 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp1_ == NULL) {
#line 645 "math-converter.c"
		GList* categories = NULL;
		UnitManager* _tmp2_;
		UnitManager* _tmp3_;
		GList* _tmp4_;
		GList* _tmp5_;
		GList* _tmp6_;
#line 124 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp2_ = unit_manager_get_default ();
#line 124 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp3_ = _tmp2_;
#line 124 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp4_ = unit_manager_get_categories (_tmp3_);
#line 124 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp5_ = _tmp4_;
#line 124 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (_tmp3_);
#line 124 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		categories = _tmp5_;
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp6_ = categories;
#line 666 "math-converter.c"
		{
			GList* category_collection = NULL;
			GList* category_it = NULL;
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			category_collection = _tmp6_;
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			for (category_it = category_collection; category_it != NULL; category_it = category_it->next) {
#line 674 "math-converter.c"
				UnitCategory* _tmp7_;
				UnitCategory* category = NULL;
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp7_ = _g_object_ref0 ((UnitCategory*) category_it->data);
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				category = _tmp7_;
#line 681 "math-converter.c"
				{
					GtkTreeIter parent = {0};
					GtkTreeStore* _tmp8_;
					GtkTreeIter _tmp9_ = {0};
					GtkTreeStore* _tmp10_;
					GtkTreeIter _tmp11_;
					UnitCategory* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					UnitCategory* _tmp16_;
					UnitCategory* _tmp17_;
					GList* _tmp18_;
#line 128 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp8_ = from_model;
#line 128 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					gtk_tree_store_append (_tmp8_, &_tmp9_, NULL);
#line 128 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					parent = _tmp9_;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp10_ = from_model;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp11_ = parent;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp12_ = category;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp13_ = unit_category_get_display_name (_tmp12_);
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp14_ = _tmp13_;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp15_ = _tmp14_;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp16_ = category;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					gtk_tree_store_set (_tmp10_, &_tmp11_, 0, _tmp15_, 1, _tmp16_, -1, -1);
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_g_free0 (_tmp15_);
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp17_ = category;
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp18_ = unit_category_get_units (_tmp17_);
#line 723 "math-converter.c"
					{
						GList* unit_collection = NULL;
						GList* unit_it = NULL;
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
						unit_collection = _tmp18_;
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
						for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 731 "math-converter.c"
							Unit* _tmp19_;
							Unit* unit = NULL;
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
							_tmp19_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
							unit = _tmp19_;
#line 738 "math-converter.c"
							{
								GtkTreeIter iter = {0};
								GtkTreeStore* _tmp20_;
								GtkTreeIter _tmp21_;
								GtkTreeIter _tmp22_ = {0};
								GtkTreeStore* _tmp23_;
								GtkTreeIter _tmp24_;
								Unit* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								UnitCategory* _tmp29_;
								Unit* _tmp30_;
#line 134 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp20_ = from_model;
#line 134 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp21_ = parent;
#line 134 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								gtk_tree_store_append (_tmp20_, &_tmp22_, &_tmp21_);
#line 134 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								iter = _tmp22_;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp23_ = from_model;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp24_ = iter;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp25_ = unit;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp26_ = unit_get_display_name (_tmp25_);
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp27_ = _tmp26_;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp28_ = _tmp27_;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp29_ = category;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_tmp30_ = unit;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								gtk_tree_store_set (_tmp23_, &_tmp24_, 0, _tmp28_, 1, _tmp29_, 2, _tmp30_, -1, -1);
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_g_free0 (_tmp28_);
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
								_g_object_unref0 (unit);
#line 782 "math-converter.c"
							}
						}
					}
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_g_object_unref0 (category);
#line 788 "math-converter.c"
				}
			}
		}
#line 122 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 794 "math-converter.c"
	} else {
		UnitCategory* c = NULL;
		UnitManager* _tmp31_;
		UnitManager* _tmp32_;
		const gchar* _tmp33_;
		UnitCategory* _tmp34_;
		UnitCategory* _tmp35_;
		UnitCategory* _tmp36_;
		GList* _tmp37_;
#line 141 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp31_ = unit_manager_get_default ();
#line 141 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 141 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp33_ = self->priv->category;
#line 141 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp34_ = unit_manager_get_category (_tmp32_, _tmp33_);
#line 141 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp35_ = _tmp34_;
#line 141 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (_tmp32_);
#line 141 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		c = _tmp35_;
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp36_ = c;
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp37_ = unit_category_get_units (_tmp36_);
#line 822 "math-converter.c"
		{
			GList* unit_collection = NULL;
			GList* unit_it = NULL;
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			unit_collection = _tmp37_;
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 830 "math-converter.c"
				Unit* _tmp38_;
				Unit* unit = NULL;
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp38_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				unit = _tmp38_;
#line 837 "math-converter.c"
				{
					GtkTreeIter iter = {0};
					GtkTreeStore* _tmp39_;
					GtkTreeIter _tmp40_ = {0};
					GtkTreeStore* _tmp41_;
					GtkTreeIter _tmp42_;
					Unit* _tmp43_;
					gchar* _tmp44_;
					gchar* _tmp45_;
					gchar* _tmp46_;
					UnitCategory* _tmp47_;
					Unit* _tmp48_;
#line 145 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp39_ = from_model;
#line 145 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					gtk_tree_store_append (_tmp39_, &_tmp40_, NULL);
#line 145 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					iter = _tmp40_;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp41_ = from_model;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp42_ = iter;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp43_ = unit;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp44_ = unit_get_display_name (_tmp43_);
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp45_ = _tmp44_;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp46_ = _tmp45_;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp47_ = c;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp48_ = unit;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					gtk_tree_store_set (_tmp41_, &_tmp42_, 0, _tmp46_, 1, _tmp47_, 2, _tmp48_, -1, -1);
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_g_free0 (_tmp46_);
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_g_object_unref0 (unit);
#line 878 "math-converter.c"
				}
			}
		}
#line 122 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (c);
#line 884 "math-converter.c"
	}
#line 150 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp49_ = self->priv->from_combo;
#line 150 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp50_ = from_model;
#line 150 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_combo_box_set_model (_tmp49_, (GtkTreeModel*) _tmp50_);
#line 118 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (from_model);
#line 894 "math-converter.c"
}


static gboolean
math_converter_iter_is_unit (MathConverter* self,
                             GtkTreeModel* model,
                             GtkTreeIter* iter,
                             Unit* unit)
{
	gboolean result = FALSE;
	Unit* u = NULL;
	GtkTreeIter _tmp0_;
#line 153 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 153 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 153 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 156 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = *iter;
#line 156 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_tree_model_get (model, &_tmp0_, 2, &u, -1, -1);
#line 157 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	result = u == unit;
#line 157 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (u);
#line 157 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return result;
#line 925 "math-converter.c"
}


static gboolean
math_converter_set_active_unit (MathConverter* self,
                                GtkComboBox* combo,
                                GtkTreeIter* iter,
                                Unit* unit)
{
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter child_iter = {0};
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	gboolean _tmp7_;
#line 160 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 160 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (combo != NULL, FALSE);
#line 160 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 162 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = gtk_combo_box_get_model (combo);
#line 162 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 162 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	model = _tmp1_;
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (iter != NULL) {
#line 958 "math-converter.c"
		GtkTreeModel* _tmp3_;
		GtkTreeIter _tmp4_;
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp3_ = model;
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp4_ = *iter;
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp2_ = math_converter_iter_is_unit (self, _tmp3_, &_tmp4_, unit);
#line 967 "math-converter.c"
	} else {
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp2_ = FALSE;
#line 971 "math-converter.c"
	}
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp2_) {
#line 165 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		gtk_combo_box_set_active_iter (combo, iter);
#line 166 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		result = TRUE;
#line 166 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (model);
#line 166 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return result;
#line 983 "math-converter.c"
	}
#line 170 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp5_ = model;
#line 170 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp7_ = gtk_tree_model_iter_children (_tmp5_, &_tmp6_, iter);
#line 170 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	child_iter = _tmp6_;
#line 170 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (!_tmp7_) {
#line 171 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		result = FALSE;
#line 171 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (model);
#line 171 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return result;
#line 999 "math-converter.c"
	}
	{
		gboolean _tmp8_ = FALSE;
#line 173 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp8_ = TRUE;
#line 173 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		while (TRUE) {
#line 1007 "math-converter.c"
			GtkTreeIter _tmp11_;
#line 173 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			if (!_tmp8_) {
#line 1011 "math-converter.c"
				GtkTreeModel* _tmp9_;
				gboolean _tmp10_;
#line 177 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp9_ = model;
#line 177 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp10_ = gtk_tree_model_iter_next (_tmp9_, &child_iter);
#line 177 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				if (!_tmp10_) {
#line 177 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					break;
#line 1022 "math-converter.c"
				}
			}
#line 173 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			_tmp8_ = FALSE;
#line 175 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			_tmp11_ = child_iter;
#line 175 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			if (math_converter_set_active_unit (self, combo, &_tmp11_, unit)) {
#line 176 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				result = TRUE;
#line 176 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_g_object_unref0 (model);
#line 176 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				return result;
#line 1037 "math-converter.c"
			}
		}
	}
#line 179 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	result = FALSE;
#line 179 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (model);
#line 179 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return result;
#line 1047 "math-converter.c"
}


static void
math_converter_from_combobox_changed_cb (MathConverter* self)
{
	UnitCategory* category = NULL;
	UnitCategory* to_category = NULL;
	Unit* unit = NULL;
	GtkTreeIter iter = {0};
	GtkTreeIter to_iter = {0};
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* to_model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	GtkComboBox* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	GtkTreeModel* _tmp9_;
	GtkTreeIter _tmp10_;
	GtkComboBox* _tmp11_;
	GtkTreeIter _tmp12_ = {0};
	gboolean _tmp13_;
	UnitCategory* _tmp16_;
	UnitCategory* _tmp17_;
#line 183 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 185 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	category = NULL;
#line 185 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	to_category = NULL;
#line 189 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 189 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 189 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 189 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	model = _tmp2_;
#line 190 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp3_ = self->priv->to_combo;
#line 190 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 190 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_list_store_get_type ()) ? ((GtkListStore*) _tmp4_) : NULL);
#line 190 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	to_model = _tmp5_;
#line 192 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp6_ = self->priv->from_combo;
#line 192 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp8_ = gtk_combo_box_get_active_iter (_tmp6_, &_tmp7_);
#line 192 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	iter = _tmp7_;
#line 192 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (!_tmp8_) {
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (to_model);
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (model);
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (unit);
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (to_category);
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (category);
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return;
#line 1119 "math-converter.c"
	}
#line 195 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp9_ = model;
#line 195 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp10_ = iter;
#line 195 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_tree_model_get (_tmp9_, &_tmp10_, 1, &category, 2, &unit, -1, -1);
#line 196 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp11_ = self->priv->to_combo;
#line 196 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp13_ = gtk_combo_box_get_active_iter (_tmp11_, &_tmp12_);
#line 196 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	to_iter = _tmp12_;
#line 196 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp13_) {
#line 1135 "math-converter.c"
		GtkListStore* _tmp14_;
		GtkTreeIter _tmp15_;
#line 197 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp14_ = to_model;
#line 197 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp15_ = to_iter;
#line 197 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp14_, &_tmp15_, 1, &to_category, -1);
#line 1144 "math-converter.c"
	}
#line 199 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp16_ = category;
#line 199 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp17_ = to_category;
#line 199 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp16_ != _tmp17_) {
#line 1152 "math-converter.c"
		GtkListStore* _tmp18_;
		UnitCategory* _tmp19_;
		GList* _tmp20_;
		GtkComboBox* _tmp32_;
		GtkListStore* _tmp33_;
		GtkComboBox* _tmp34_;
#line 202 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp18_ = gtk_list_store_new (3, G_TYPE_STRING, TYPE_UNIT_CATEGORY, TYPE_UNIT, -1);
#line 202 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (to_model);
#line 202 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		to_model = _tmp18_;
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp19_ = category;
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp20_ = unit_category_get_units (_tmp19_);
#line 1169 "math-converter.c"
		{
			GList* u_collection = NULL;
			GList* u_it = NULL;
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			u_collection = _tmp20_;
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			for (u_it = u_collection; u_it != NULL; u_it = u_it->next) {
#line 1177 "math-converter.c"
				Unit* _tmp21_;
				Unit* u = NULL;
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				_tmp21_ = _g_object_ref0 ((Unit*) u_it->data);
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
				u = _tmp21_;
#line 1184 "math-converter.c"
				{
					GtkListStore* _tmp22_;
					GtkTreeIter _tmp23_ = {0};
					GtkListStore* _tmp24_;
					GtkTreeIter _tmp25_;
					Unit* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					UnitCategory* _tmp30_;
					Unit* _tmp31_;
#line 205 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp22_ = to_model;
#line 205 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					gtk_list_store_append (_tmp22_, &_tmp23_);
#line 205 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					iter = _tmp23_;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp24_ = to_model;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp25_ = iter;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp26_ = u;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp27_ = unit_get_display_name (_tmp26_);
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp28_ = _tmp27_;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp29_ = _tmp28_;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp30_ = category;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_tmp31_ = u;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					gtk_list_store_set (_tmp24_, &_tmp25_, 0, _tmp29_, 1, _tmp30_, 2, _tmp31_, -1, -1);
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_g_free0 (_tmp29_);
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
					_g_object_unref0 (u);
#line 1224 "math-converter.c"
				}
			}
		}
#line 208 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp32_ = self->priv->to_combo;
#line 208 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp33_ = to_model;
#line 208 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		gtk_combo_box_set_model (_tmp32_, (GtkTreeModel*) _tmp33_);
#line 211 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp34_ = self->priv->to_combo;
#line 211 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		gtk_combo_box_set_active (_tmp34_, 0);
#line 1238 "math-converter.c"
	}
#line 183 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (to_model);
#line 183 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (model);
#line 183 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (unit);
#line 183 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (to_category);
#line 183 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (category);
#line 1250 "math-converter.c"
}


static void
_math_converter_from_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_from_combobox_changed_cb ((MathConverter*) self);
#line 1260 "math-converter.c"
}


static void
math_converter_to_combobox_changed_cb (MathConverter* self)
{
#line 216 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 219 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_update_result_label (self);
#line 220 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL], 0);
#line 1273 "math-converter.c"
}


static void
_math_converter_to_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                              gpointer self)
{
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_to_combobox_changed_cb ((MathConverter*) self);
#line 1283 "math-converter.c"
}


static void
math_converter_from_cell_data_func (MathConverter* self,
                                    GtkCellLayout* cell_layout,
                                    GtkCellRenderer* cell,
                                    GtkTreeModel* tree_model,
                                    GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
#line 223 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 223 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (cell_layout != NULL);
#line 223 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (cell != NULL);
#line 223 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (tree_model != NULL);
#line 223 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (iter != NULL);
#line 225 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = *iter;
#line 225 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_object_set ((GObject*) cell, "sensitive", !gtk_tree_model_iter_has_child (tree_model, &_tmp0_), NULL);
#line 1309 "math-converter.c"
}


static void
math_converter_swap_button_clicked_cb (MathConverter* self)
{
	Number* x = NULL;
	MathEquation* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp9_ = NULL;
	Unit* _tmp10_ = NULL;
	GtkComboBox* _tmp11_;
	GtkComboBox* _tmp12_;
#line 229 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 231 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->equation;
#line 231 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = math_equation_get_number (_tmp0_);
#line 231 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 231 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	x = _tmp2_;
#line 232 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp3_ = x;
#line 232 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (_tmp3_ != NULL) {
#line 1341 "math-converter.c"
		Number* z = NULL;
		Number* _tmp4_;
		Number* _tmp5_;
		Number* _tmp6_;
#line 234 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp4_ = x;
#line 234 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp5_ = math_converter_convert_equation (self, _tmp4_);
#line 234 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		z = _tmp5_;
#line 235 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_tmp6_ = z;
#line 235 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		if (_tmp6_ != NULL) {
#line 1356 "math-converter.c"
			MathEquation* _tmp7_;
			Number* _tmp8_;
#line 236 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			_tmp7_ = self->priv->equation;
#line 236 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			_tmp8_ = z;
#line 236 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
			math_equation_set_number (_tmp7_, _tmp8_, (guint) 0);
#line 1365 "math-converter.c"
		}
#line 232 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		_g_object_unref0 (z);
#line 1369 "math-converter.c"
	}
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_get_conversion (self, &_tmp9_, &_tmp10_);
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	from_unit = _tmp9_;
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	to_unit = _tmp10_;
#line 241 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp11_ = self->priv->from_combo;
#line 241 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp11_, NULL, to_unit);
#line 242 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp12_ = self->priv->to_combo;
#line 242 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp12_, NULL, from_unit);
#line 244 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_update_result_label (self);
#line 229 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 229 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 229 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (x);
#line 1397 "math-converter.c"
}


static void
_math_converter_swap_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_swap_button_clicked_cb ((MathConverter*) self);
#line 1407 "math-converter.c"
}


static Number*
math_converter_convert_equation (MathConverter* self,
                                 Number* x)
{
	Number* result = NULL;
	GtkTreeIter from_iter = {0};
	GtkTreeIter to_iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkComboBox* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
	UnitCategory* category = NULL;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	GtkComboBox* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeModel* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkComboBox* _tmp10_;
	GtkTreeModel* _tmp11_;
	GtkTreeModel* _tmp12_;
	GtkTreeIter _tmp13_;
	UnitCategory* _tmp14_;
	Unit* _tmp15_;
	Unit* _tmp16_;
	Number* _tmp17_;
#line 247 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 250 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 250 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 250 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	from_iter = _tmp1_;
#line 250 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (!_tmp2_) {
#line 251 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		result = NULL;
#line 251 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return result;
#line 1455 "math-converter.c"
	}
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp3_ = self->priv->to_combo;
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp5_ = gtk_combo_box_get_active_iter (_tmp3_, &_tmp4_);
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	to_iter = _tmp4_;
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	if (!_tmp5_) {
#line 253 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		result = NULL;
#line 253 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
		return result;
#line 1469 "math-converter.c"
	}
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp6_ = self->priv->from_combo;
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp7_ = gtk_combo_box_get_model (_tmp6_);
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp9_ = from_iter;
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_tree_model_get (_tmp8_, &_tmp9_, 1, &category, 2, &source_unit, -1, -1);
#line 258 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp10_ = self->priv->to_combo;
#line 258 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp11_ = gtk_combo_box_get_model (_tmp10_);
#line 258 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 258 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp13_ = to_iter;
#line 258 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_tree_model_get (_tmp12_, &_tmp13_, 2, &target_unit, -1, -1);
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp14_ = category;
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp15_ = source_unit;
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp16_ = target_unit;
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp17_ = unit_category_convert (_tmp14_, x, _tmp15_, _tmp16_);
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	result = _tmp17_;
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (category);
#line 260 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return result;
#line 1509 "math-converter.c"
}


static void
_math_converter_from_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                               GtkCellRenderer* cell,
                                                               GtkTreeModel* tree_model,
                                                               GtkTreeIter* iter,
                                                               gpointer self)
{
#line 34 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_from_cell_data_func ((MathConverter*) self, cell_layout, cell, tree_model, iter);
#line 1522 "math-converter.c"
}


static void
_math_converter___lambda12_ (MathConverter* self)
{
#line 35 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_update_result_label (self);
#line 1531 "math-converter.c"
}


static void
__math_converter___lambda12__currency_manager_updated (CurrencyManager* _sender,
                                                       gpointer self)
{
#line 35 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_math_converter___lambda12_ ((MathConverter*) self);
#line 1541 "math-converter.c"
}


static GObject *
math_converter_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MathConverter * self;
	GtkComboBox* _tmp0_;
	GtkCellRendererText* _tmp1_;
	CurrencyManager* _tmp2_;
	CurrencyManager* _tmp3_;
#line 32 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	parent_class = G_OBJECT_CLASS (math_converter_parent_class);
#line 32 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 34 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 34 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp1_ = self->priv->from_renderer;
#line 34 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp0_, (GtkCellRenderer*) _tmp1_, _math_converter_from_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 35 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp2_ = currency_manager_get_default ();
#line 35 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 35 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_signal_connect_object (_tmp3_, "updated", (GCallback) __math_converter___lambda12__currency_manager_updated, self, 0);
#line 35 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (_tmp3_);
#line 37 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_update_from_model (self);
#line 32 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	return obj;
#line 1581 "math-converter.c"
}


static void
math_converter_class_init (MathConverterClass * klass)
{
	gint MathConverter_private_offset;
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_parent_class = g_type_class_peek_parent (klass);
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	g_type_class_add_private (klass, sizeof (MathConverterPrivate));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	G_OBJECT_CLASS (klass)->constructor = math_converter_constructor;
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	G_OBJECT_CLASS (klass)->finalize = math_converter_finalize;
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	MathConverter_private_offset = g_type_class_get_instance_private_offset (klass);
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-converter.ui");
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_MATH_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_renderer", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_renderer));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_combo));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_combo));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_label", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_label));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_label", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_label));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_combobox_changed_cb", G_CALLBACK(_math_converter_from_combobox_changed_cb_gtk_combo_box_changed));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_combobox_changed_cb", G_CALLBACK(_math_converter_to_combobox_changed_cb_gtk_combo_box_changed));
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "swap_button_clicked_cb", G_CALLBACK(_math_converter_swap_button_clicked_cb_gtk_button_clicked));
#line 1619 "math-converter.c"
}


static void
math_converter_instance_init (MathConverter * self)
{
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	self->priv = MATH_CONVERTER_GET_PRIVATE (self);
#line 14 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	self->priv->equation = NULL;
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1632 "math-converter.c"
}


static void
math_converter_finalize (GObject * obj)
{
	MathConverter * self;
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 14 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (self->priv->equation);
#line 16 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 19 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (self->priv->from_renderer);
#line 22 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (self->priv->from_combo);
#line 24 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (self->priv->to_combo);
#line 26 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (self->priv->from_label);
#line 28 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	_g_object_unref0 (self->priv->to_label);
#line 12 "/builddir/build/BUILD/gnome-calculator-3.28.2/src/math-converter.vala"
	G_OBJECT_CLASS (math_converter_parent_class)->finalize (obj);
#line 1658 "math-converter.c"
}


GType
math_converter_get_type (void)
{
	static volatile gsize math_converter_type_id__volatile = 0;
	if (g_once_init_enter (&math_converter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MathConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathConverter), 0, (GInstanceInitFunc) math_converter_instance_init, NULL };
		GType math_converter_type_id;
		math_converter_type_id = g_type_register_static (gtk_grid_get_type (), "MathConverter", &g_define_type_info, 0);
		g_once_init_leave (&math_converter_type_id__volatile, math_converter_type_id);
	}
	return math_converter_type_id__volatile;
}



